/*
 * light_trace.c
 *
 *  Created on: 18.05.2019
 *      Author: terfloth
 */

#include <stdio.h>

#include "light_trace.h"
#include "sc/Light.h"
#include "sc/LightRequired.h"

static char* stateNames[] = {
		"NoState",
		"multi_click.idle",
		"multi_click.clicking",
		"light_control.Off",
		"light_control.Off.Off",
		"light_control.Off.On",
		"light_control.On"
};

bool light_trace_active = true;


/*! This function is called when a state is entered. */
void light_stateEntered(Light* handle, const LightStates state) {
	if (light_trace_active) fprintf(stderr, "-> [%s]\n", stateNames[state]);
}

/*! This function is called when a state is exited. */
void light_stateExited(Light* handle, const LightStates state) {
	if (light_trace_active) fprintf(stderr, "[%s] ->\n", stateNames[state]);
}
