/*
 * light_sensors.c
 *
 *  Created on: 19.05.2018
 *      Author: terfloth
 */

#include "light_sensors.h"

#include <stdbool.h>
#include <stdio.h>

#include "light_trace.h"



static SensorEvents lastEvent = NONE;


SensorEvents provideSensorEvent() {
	SensorEvents sensorEvent = lastEvent;
	lastEvent = NONE;
	return sensorEvent;
}


void scanUserInput() {
	while (1) {
		char c;

		c = getchar();

		switch (c) {
			case 'b':
			case 'd':
				lastEvent = BUTTON_DOWN;
				break;
			case 'm':
				lastEvent = MOTION_DETECTED;
				break;
			case 't':
				light_trace_active = !light_trace_active;
				break;
			case 'q':
				return;
			case '\n':
				break;
			default:
				lastEvent = NONE;
		}
	}
}

void show(char* text) {

	fprintf(stdout, "%s", text);
	fflush(stdout);
}

