/** Generated by YAKINDU Statechart Tools code generator. */

#ifndef LIGHT_H_
#define LIGHT_H_

#include "sc_types.h"

#ifdef __cplusplus
extern "C" { 
#endif 

/*! \file Header of the state machine 'Light'.
*/

/*! Define number of states in the state enum */

#define LIGHT_STATE_COUNT 6

/*! Define dimension of the state configuration vector for orthogonal states. */
#define LIGHT_MAX_ORTHOGONAL_STATES 2

/*! Define maximum number of time events that can be active at once */
#define LIGHT_MAX_PARALLEL_TIME_EVENTS 2

/*! Define indices of states in the StateConfVector */
#define SCVI_LIGHT_MULTI_CLICK_IDLE 0
#define SCVI_LIGHT_MULTI_CLICK_CLICKING 0
#define SCVI_LIGHT_LIGHT_CONTROL_OFF 1
#define SCVI_LIGHT_LIGHT_CONTROL_OFF__REGION0_OFF 1
#define SCVI_LIGHT_LIGHT_CONTROL_OFF__REGION0_ON 1
#define SCVI_LIGHT_LIGHT_CONTROL_ON 1

/*! Enumeration of all states */ 
typedef enum
{
	Light_last_state,
	Light_multi_click_idle,
	Light_multi_click_clicking,
	Light_light_control_Off,
	Light_light_control_Off__region0_Off,
	Light_light_control_Off__region0_On,
	Light_light_control_On
} LightStates;

/*! Type definition of the data structure for the LightIfaceButton interface scope. */
typedef struct
{
	sc_boolean down_raised;
} LightIfaceButton;



/*! Type definition of the data structure for the LightIfaceWire interface scope. */
typedef struct
{
	sc_integer power;
} LightIfaceWire;



/*! Type definition of the data structure for the LightIfaceSensor interface scope. */
typedef struct
{
	sc_boolean motion_raised;
} LightIfaceSensor;



/*! Type definition of the data structure for the LightInternal interface scope. */
typedef struct
{
	sc_integer button_down_count;
	sc_boolean clicked_raised;
	sc_integer clicked_value;
} LightInternal;



/*! Type definition of the data structure for the LightTimeEvents interface scope. */
typedef struct
{
	sc_boolean light_multi_click_clicking_tev0_raised;
	sc_boolean light_light_control_Off__region0_On_tev0_raised;
} LightTimeEvents;




/*! 
 * Type definition of the data structure for the Light state machine.
 * This data structure has to be allocated by the client code. 
 */
typedef struct
{
	LightStates stateConfVector[LIGHT_MAX_ORTHOGONAL_STATES];
	sc_ushort stateConfVectorPosition; 
	
	LightIfaceButton ifaceButton;
	LightIfaceWire ifaceWire;
	LightIfaceSensor ifaceSensor;
	LightInternal internal;
	LightTimeEvents timeEvents;
} Light;



/*! Initializes the Light state machine data structures. Must be called before first usage.*/
extern void light_init(Light* handle);

/*! Activates the state machine */
extern void light_enter(Light* handle);

/*! Deactivates the state machine */
extern void light_exit(Light* handle);

/*! Performs a 'run to completion' step. */
extern void light_runCycle(Light* handle);

/*! Raises a time event. */
extern void light_raiseTimeEvent(Light* handle, sc_eventid evid);

/*! Raises the in event 'down' that is defined in the interface scope 'button'. */ 
extern void lightIfaceButton_raise_down(Light* handle);

/*! Gets the value of the variable 'power' that is defined in the interface scope 'wire'. */ 
extern sc_integer lightIfaceWire_get_power(const Light* handle);
/*! Sets the value of the variable 'power' that is defined in the interface scope 'wire'. */ 
extern void lightIfaceWire_set_power(Light* handle, sc_integer value);
/*! Raises the in event 'motion' that is defined in the interface scope 'sensor'. */ 
extern void lightIfaceSensor_raise_motion(Light* handle);


/*!
 * Checks whether the state machine is active (until 2.4.1 this method was used for states).
 * A state machine is active if it was entered. It is inactive if it has not been entered at all or if it has been exited.
 */
extern sc_boolean light_isActive(const Light* handle);

/*!
 * Checks if all active states are final. 
 * If there are no active states then the state machine is considered being inactive. In this case this method returns false.
 */
extern sc_boolean light_isFinal(const Light* handle);

/*! Checks if the specified state is active (until 2.4.1 the used method for states was called isActive()). */
extern sc_boolean light_isStateActive(const Light* handle, LightStates state);


#ifdef __cplusplus
}
#endif 

#endif /* LIGHT_H_ */
